// This macro is to shift image for stage-scanning DiSPIM. 
// Min Guo, Dec 2016

while (nImages>0) {
          selectImage(nImages); 
          close(); 
      }
print("Parameters setting...");
Dialog.create("Image_Shifting");
items = newArray("Single View", "Dual View");
Dialog.addRadioButtonGroup("Set View", items, 1, 2, "Dual View");
Dialog.addMessage("Set Time Points");
Dialog.addNumber("Start Time", 1);
Dialog.addNumber("End Time", 2);
Dialog.addNumber("Test Time", 1);
//Dialog.addMessage("\n");
items = newArray("Pixels","Distance");
Dialog.addRadioButtonGroup("Set Slice Step Type", items, 1, 2, "Pixels");
Dialog.addNumber("Pixels:", 4,0,6,"");
Dialog.addNumber("Distance: interval", 0.5,1,6,"um");
Dialog.addNumber("Distance: pixelsize", 0.1625,4,6,"um");
Dialog.addMessage("Set Shifting Direction");
items = newArray("Left2Right", "Right2Left");
Dialog.addChoice("Direction A", items, "Right2Left");
items = newArray("Left2Right", "Right2Left");
Dialog.addChoice("Direction B", items, "Right2Left");
Dialog.addMessage("\n");
items = newArray("Default", "Custom");
Dialog.addChoice("File Naming Convention", items, "Default");
//Dialog.addMessage("Default: specify main Directory");
//Dialog.addMessage("Custom: specify all input and out paths");
Dialog.addMessage("Specify Images Name");
Dialog.addString("Name A","SPIMA_",20);
Dialog.addString("Name B","SPIMB_",20);
items = newArray("none subtraction", "background mean value","background images","manually select background area","automatically background subtraction");
Dialog.addChoice("Background Subtraction", items, "automatically background subtraction");
Dialog.show();

viewn = Dialog.getRadioButton();
tStart = Dialog.getNumber();
tEnd = Dialog.getNumber();
tTest = Dialog.getNumber();

if((tTest<tStart)||(tTest>tEnd))
tTest = tStart;
sd1 = Dialog.getChoice();
sd2 = Dialog.getChoice();
if(sd1=="Left2Right")
	d1 = 1;
else
	d1 = -1;
if(sd2=="Left2Right")
	d2 = 1;
else
	d2 = -1;
stepType = Dialog.getRadioButton();
pixel = Dialog.getNumber();
interval = Dialog.getNumber();
pixelsize = Dialog.getNumber();
if(stepType=="Distance")
	shiftStep = interval/1.414/pixelsize;
else
	shiftStep = pixel;
namingConvention = Dialog.getChoice();
name1 = Dialog.getString();
name2 = Dialog.getString();
//name1 = name1+"_";
//name2 = name2+"_";
if(namingConvention=="Default"){
	path = getDirectory("Choose Main Directory");
	inPut1 = path+"/SPIMA";
	inPut2 = path+"/SPIMB";
	outPut1 = path+"/Shifted_SPIMA";
	outPut2 = path+"/Shifted_SPIMB";
}
else{
	inPut1 = getDirectory("Choose Input Directory for A view");
	outPut1 = getDirectory("Choose Output Directory for A view");
	if(viewn=="Dual View"){
		inPut2 = getDirectory("Choose Input Directory for B view");
		outPut2 = getDirectory("Choose Output Directory for B view");
	}	
}

bs = Dialog.getChoice();

list = getFileList(inPut1);
if (endsWith(list[0], "/"))
	sequence = 1;
else
	sequence = 0;

Tole = 40;
Tolez = 10;

// Background Subtraction//
print("Getting background information...");
bmeans = getBmean(bs);
//print(bmeans[0]);
print("Getting background information is completed.");

// Select Region of Interest //
// Preprocessing
print("ROI selecting...");
File.makeDirectory(outPut1);
File.makeDirectory(outPut1+"/MP");
dir = inPut1+"/"+name1+tTest;
bmeans[0] = fshifting(dir,shiftStep,sequence,d1,bmeans[0]);
//run("Flip Horizontally", "stack");
//run("Flip Z");
ID1 = getImageID();//Title1=getTitle();
run("Z Project...", "projection=[Max Intensity]");
ID2 = getImageID();//Title2=getTitle();
sxA = getWidth();
syA = getHeight();

if(viewn=="Dual View")
{
	File.makeDirectory(outPut2);
	File.makeDirectory(outPut2+"/MP");
	dir = inPut2+"/"+name2+tTest;
	bmeans[1] = fshifting(dir,shiftStep,sequence,d2,bmeans[1]);
	ID3 = getImageID();//Title3=getTitle();
	run("Z Project...", "projection=[Max Intensity]");
	ID4 = getImageID();//Title4=getTitle();
	sxB = getWidth();
	syB = getHeight();
}

// ROI detection
// selectImage(ID1);//selectWindow(Title1);
// close();
RA = roiDetection(ID2,Tole);
	
if(viewn=="Dual View")
{  		
	// selectImage(ID3);//selectWindow(Title3);
	// close();
	RB = roiDetection(ID4,Tole);

	
	if(RA[2]>sxB)
		RA[2] = sxB;
	if(RA[3]>syB)
		RA[2] = sxB;
	if(RB[2]>sxA)
		RB[2] = sxA;
	if(RB[3]>syA)
		RB[3] = syA;
	
	if(RA[2]>RB[2])
		RB[2] = RA[2];
	else
		RA[2] = RB[2];
	if(RA[3]>RB[3])
		RB[3] = RA[3];
	else
		RA[3] = RB[3];
	if((RA[0]+RA[2])>sxA)
		RA[0]=sxA-RA[2]-1;
	if((RA[1]+RA[3])>sxA)
		RA[1]=sxA-RA[3]-1;
	if((RB[0]+RB[2])>sxA)
		RB[0]=sxA-RB[2]-1;
	if((RB[1]+RB[3])>sxA)
		RB[1]=sxA-RB[3]-1;
	
	selectImage(ID4);//selectWindow(Title4);
	makeRectangle(RB[0], RB[1], RB[2], RB[3]);
}
selectImage(ID2);//selectWindow(Title2);	
makeRectangle(RA[0], RA[1], RA[2], RA[3]);

// Manually select ROI ///
waitForUser("Selection","Select Region of Interest for Z projection, then press OK");
selectImage(ID2);//selectWindow(Title2);
getSelectionBounds(xA, yA, wA, hA);
wA = floor(wA/10)*10;
hA = floor(hA/10)*10;
close();
if(viewn=="Dual View")
{
	selectImage(ID4);//selectWindow(Title4);
	getSelectionBounds(xB, yB, wB, hB);
	wB = floor(wB/10)*10;
	hB = floor(hB/10)*10;
	close();
}

// z stacks
selectImage(ID1);
run("Reslice [/]...", "output=1.000 start=Top avoid");
ID5 = getImageID();//Title1=getTitle();
run("Z Project...", "projection=[Max Intensity]");
ID6 = getImageID();
szA = getHeight();
selectImage(ID1);
close();
selectImage(ID5);
close();

if(viewn=="Dual View")
{	
	selectImage(ID3);
	run("Reslice [/]...", "output=1.000 start=Top avoid");
	ID7 = getImageID();//Title1=getTitle();
	run("Z Project...", "projection=[Max Intensity]");
	ID8 = getImageID();
	szB = getHeight();
	selectImage(ID3);
	close();
	selectImage(ID7);
	close();
	RBz = roiDetection(ID8,Tolez);
}

RAz = roiDetection(ID6,Tolez);

if(viewn=="Dual View")
{  		
	RB = roiDetection(ID8,Tolez);
	if(RAz[3]>szB)
		RAz[3] = szB;
	if(RBz[3]>szA)
		RBz[3] = szA;
	if(RAz[3]>RBz[3])
		RBz[3] = RAz[3];
	else
		RAz[3] = RBz[3];
	if((RAz[1]+RAz[3])>szA)
		RAz[1]=szA-RAz[3]-1;
	if((RBz[1]+RBz[3])>szB)
		RBz[1]=sxA-RBz[3]-1;
	
	selectImage(ID8);//selectWindow(Title4);
	makeRectangle(xB, RBz[1], wB, RBz[3]);
}
selectImage(ID6);//selectWindow(Title2);	
makeRectangle(xA, RAz[1], wA, RAz[3]);

// Manually select z stacks ///
waitForUser("Selection","Select Region of Interest for y projection, then press OK");
selectImage(ID6);//selectWindow(Title2);
getSelectionBounds(aa, zA1, bb, sA);
zA2 = zA1 + sA;
close();
if(viewn=="Dual View")
{
	selectImage(ID8);//selectWindow(Title4);
	getSelectionBounds(aa, zB1, bb, sB);
	zB2 = zB1 + sB;
	close();
}

print("ROI selecting is completed.");
print("Average value of A view background: "+ bmeans[0]);
print("Average value of B view background: "+ bmeans[1]);
// Image shifting begins ////////
setBatchMode(true);
print("Shifting begins...");
for(i=tStart;i<=tEnd;i++){
	print("Processing time point "+i+" ...");
	dir = inPut1+"/"+name1+i;
	fshifting(dir,shiftStep,sequence,d1,bmeans[0]);
	//run("Flip Horizontally", "stack");
	makeRectangle(xA, yA, wA, hA);
  	run("Crop");
  	//run("Flip Z");
  	ID9 = getImageID();
  	run("Duplicate...", "duplicate range="+zA1+"-"+zA2);
  	selectImage(ID9);
	close();
  	saveAs("Tiff", outPut1+"/"+name1+i+".tif");
  	run("Z Project...", "projection=[Max Intensity]");
  	saveAs("Tiff", outPut1+"/MP/Max_"+name1+i+".tif");
  	close();
  	close();

	if(viewn=="Dual View")
	{
		dir = inPut2+"/"+name2+i;
		fshifting(dir,shiftStep,sequence,d2,bmeans[1]);
		makeRectangle(xB, yB, wB, hB);
  		run("Crop");
  		ID10 = getImageID();
  		run("Duplicate...", "duplicate range="+zB1+"-"+zB2);
  		selectImage(ID10);
		close();
  		saveAs("Tiff", outPut2+"/"+name2+i+".tif");
  		run("Z Project...", "projection=[Max Intensity]");
  		saveAs("Tiff", outPut2+"/MP/Max_"+name2+i+".tif");
  		close();
  		close();
	}
}
print("Shifting is completed !");


//function for shifting image
function fshifting(dir,shiftStep,sequence,d, bmean){
	if(sequence==1){
		list = getFileList(dir);
		//print(list[0]);
		run("Image Sequence...", "open=["+dir+"\\"+list[0]+"] sort");
	}
	else
		open(dir+".tif");
	sx = getWidth();
	sy = getHeight();
	slice = nSlices();
	if(bmean==-1){ // automatically background value estimation
		setSlice(1);
		bmeanfirst = autoBmean();
		setSlice(slice);
		bmeanlast = autoBmean();
		bmean = (bmeanfirst+bmeanlast)/2;
	}
	ID = getImageID();
	backgroundSubtraction(ID,bmean);
	sx = round(slice*shiftStep) + sx + 10;
	if(d==1)
		run("Canvas Size...", "width=sx height=sy position=Center-Left zero");
	else
		run("Canvas Size...", "width=sx height=sy position=Center-Right zero");		
	for (j=1;j<=slice;j++)
	{
		setSlice(j);
		shift = j*shiftStep*d;
		run("Translate...", "x=shift y=0 interpolation=Bilinear slice");
	}
	return bmean;
}

//function for ROI detection
function roiDetection(ID,Tole){
	selectImage(ID);
	sxA = getWidth();
	syA = getHeight();
	run("Duplicate...", " ");
	run("8-bit");
	run("Gray Morphology", "radius=3 type=[ver line] operator=erode"); // eliminate horizontal artifact lines
	run("Gray Morphology", "radius=3 type=[hor line] operator=erode"); // eliminate horizontal artifact lines
	run("Auto Threshold", "method=Triangle white");
	run("Dilate");
	run("Dilate");
	run("Dilate"); // eliminate small particles
	run("Select Bounding Box (guess background color)");
	getSelectionBounds(xA, yA, wA, hA);
	xA = xA - Tole;
	yA = yA - Tole;
	wA = floor(wA/10)*10+Tole*2;
	hA = floor(hA/10)*10+Tole*2;
	close();
	if(wA>sxA)
		wA=sxA;
	if(hA>syA)
		hA=syA;
	if(xA<0) 
		xA = 0;
	if(yA<0)
		yA = 0;
	R = newArray(4);
	R[0] = xA;
	R[1] = yA;
	R[2] = wA;
	R[3] = hA;
	return R;
}

function backgroundSubtraction(ID,bmean){
	run("Subtract...", "value="+bmean+" stack");
}


// Get background meam value
function getBmean(bs){
	bmeanA = 0;
	bmeanB = 0;
	if(bs=="none subtraction"){
	}
	else if(bs=="background mean value"){
		Dialog.create("Background Subtraction");
		Dialog.addNumber("Background mean value for A view", 100);
		Dialog.addNumber("Background mean value for B view", 100);
		bmeanA = Dialog.getNumber();
		bmeanB = Dialog.getNumber();
		Dialog.show();
	}
	else if(bs=="background images"){
		waitForUser("Background Subtraction","Open background image for A view, then press OK");
		sliceb = nSlices();
		sum = 0;
		for(i=1;i<=sliceb;i++){
			setSlice(i);
			getStatistics(area, mean);
			sum = sum+mean;
		}
		bmeanA = sum/sliceb;
		close();
		if(viewn=="Dual View"){
			waitForUser("Background Subtraction","Open background image for B view, then press OK");
			sliceb = nSlices();
			sum = 0;
			for(i=1;i<=sliceb;i++){
				setSlice(i);
				getStatistics(area, mean);
				sum = sum+mean;
			}
			bmeanB = sum/sliceb;
			close();
		}
	}
	else if(bs=="manually select background area"){
		waitForUser("Background Subtraction","Open a raw image of A view and select a background area, then press OK");
		getStatistics(area, bmeanA);
		close();
		if(viewn=="Dual View"){
			waitForUser("Background Subtraction","Open a raw image of B view and select a background area, then press OK");
			getStatistics(area, bmeanB);
			close();
		}
	}
	else if(bs=="automatically background subtraction"){
		bmeanA = -1;
		bmeanB = -1;
	}
	bmeans = newArray(2);
	bmeans[0]=bmeanA;
	bmeans[1]=bmeanB;
	return bmeans;
}
// function for estimate background based on histgram
function autoBmean(){
	nbins = 1000;
	histmax = 1000;
	getHistogram(values, counts, nbins, 0, histmax);
	imax = 0;
	for(i = 0; i<nbins; i++){
		if(counts[imax]<counts[i]) {
			imax = i;
		}		
	}
	if (imax < 5){
		bmean = values[imax];
	}
	else{
		bsum = 0;
		isum = 0;
		for(i = imax-5; i<imax+5; i++){
			bsum = bsum + values[i]*counts[i];
			isum = isum + counts[i];
		}
		bmean = bsum/isum;
	}
	return bmean;
}
